diff --git a/tests/btrfs/004 b/tests/btrfs/004
index 78df6a3a..381ad072 100755
--- a/tests/btrfs/004
+++ b/tests/btrfs/004
@@ -10,7 +10,7 @@
 # We check to end up back at the original file with the correct offset.
 #
 . ./common/preamble
-_begin_fstest auto rw metadata fiemap logical_resolve
+_begin_fstest auto rw metadata fiemap logical_resolve compress
 
 noise_pid=0
 
diff --git a/tests/btrfs/005 b/tests/btrfs/005
index 878a8c7c..84634770 100755
--- a/tests/btrfs/005
+++ b/tests/btrfs/005
@@ -7,7 +7,7 @@
 # Btrfs Online defragmentation tests
 #
 . ./common/preamble
-_begin_fstest auto defrag
+_begin_fstest auto defrag compress
 cnt=119
 filesize=48000
 
diff --git a/tests/btrfs/048 b/tests/btrfs/048
index 93d4a171..7816a997 100755
--- a/tests/btrfs/048
+++ b/tests/btrfs/048
@@ -11,7 +11,7 @@
 #  btrfs: fix zstd compression parameter
 #
 . ./common/preamble
-_begin_fstest auto quick
+_begin_fstest auto quick compress
 
 # Override the default cleanup function.
 _cleanup()
diff --git a/tests/btrfs/052 b/tests/btrfs/052
index 4408de21..0d60d413 100755
--- a/tests/btrfs/052
+++ b/tests/btrfs/052
@@ -9,7 +9,7 @@
 # file.
 #
 . ./common/preamble
-_begin_fstest auto quick clone
+_begin_fstest auto quick clone compress
 
 # Override the default cleanup function.
 _cleanup()
diff --git a/tests/btrfs/056 b/tests/btrfs/056
index e5ac516d..e1263983 100755
--- a/tests/btrfs/056
+++ b/tests/btrfs/056
@@ -15,7 +15,7 @@
 #    Btrfs: make fsync work after cloning into a file
 #
 . ./common/preamble
-_begin_fstest auto quick clone log
+_begin_fstest auto quick clone log compress
 
 # Override the default cleanup function.
 _cleanup()
diff --git a/tests/btrfs/059 b/tests/btrfs/059
index d2ced0ae..76a1e76e 100755
--- a/tests/btrfs/059
+++ b/tests/btrfs/059
@@ -11,7 +11,7 @@
 #     Btrfs: add missing compression property remove in btrfs_ioctl_setflags
 #
 . ./common/preamble
-_begin_fstest auto quick
+_begin_fstest auto quick compress
 
 # Override the default cleanup function.
 _cleanup()
diff --git a/tests/btrfs/094 b/tests/btrfs/094
index e94cf17b..75804465 100755
--- a/tests/btrfs/094
+++ b/tests/btrfs/094
@@ -18,7 +18,7 @@
 #   Btrfs: incremental send, fix clone operations for compressed extents
 #
 . ./common/preamble
-_begin_fstest auto quick send
+_begin_fstest auto quick send compress
 
 # Override the default cleanup function.
 _cleanup()
diff --git a/tests/btrfs/112 b/tests/btrfs/112
index c3f7fe5c..fd7aaad4 100755
--- a/tests/btrfs/112
+++ b/tests/btrfs/112
@@ -8,7 +8,7 @@
 # corruption or data loss.
 #
 . ./common/preamble
-_begin_fstest auto quick clone prealloc
+_begin_fstest auto quick clone prealloc compress
 
 # Import common functions.
 . ./common/filter
diff --git a/tests/btrfs/150 b/tests/btrfs/150
index a7d7d9cc..c21e0a66 100755
--- a/tests/btrfs/150
+++ b/tests/btrfs/150
@@ -11,7 +11,7 @@
 #	Btrfs: fix kernel oops while reading compressed data
 #
 . ./common/preamble
-_begin_fstest auto quick dangerous read_repair
+_begin_fstest auto quick dangerous read_repair compress
 
 # Import common functions.
 . ./common/filter
diff --git a/tests/btrfs/167 b/tests/btrfs/167
index fb271cfa..2cfcf100 100755
--- a/tests/btrfs/167
+++ b/tests/btrfs/167
@@ -11,7 +11,7 @@
 # ac0b4145d662 ("btrfs: scrub: Don't use inode pages for device replace")
 #
 . ./common/preamble
-_begin_fstest auto quick replace volume
+_begin_fstest auto quick replace volume compress
 
 # Import common functions.
 . ./common/filter
diff --git a/tests/btrfs/173 b/tests/btrfs/173
index 4972a5a7..6e78a826 100755
--- a/tests/btrfs/173
+++ b/tests/btrfs/173
@@ -8,7 +8,7 @@
 # CoW file nor compressed file.
 #
 . ./common/preamble
-_begin_fstest auto quick swap
+_begin_fstest auto quick swap compress
 
 . ./common/filter
 
diff --git a/tests/btrfs/174 b/tests/btrfs/174
index 0acd65f0..16305c18 100755
--- a/tests/btrfs/174
+++ b/tests/btrfs/174
@@ -8,7 +8,7 @@
 # specific to Btrfs.
 #
 . ./common/preamble
-_begin_fstest auto quick swap
+_begin_fstest auto quick swap compress
 
 . ./common/filter
 
diff --git a/tests/btrfs/259 b/tests/btrfs/259
index 358a4550..7f053ac9 100755
--- a/tests/btrfs/259
+++ b/tests/btrfs/259
@@ -8,7 +8,7 @@
 # at their max capacity.
 #
 . ./common/preamble
-_begin_fstest auto quick defrag fiemap
+_begin_fstest auto quick defrag fiemap compress
 
 # Import common functions.
 . ./common/filter