diff --git a/tests/btrfs/304.out b/tests/btrfs/304.out
index 39f56f32274d..97ec27455b01 100644
--- a/tests/btrfs/304.out
+++ b/tests/btrfs/304.out
@@ -12,8 +12,7 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 0 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 16
 			stripe 0 devid 1 physical XXXXXXXXX
 total bytes XXXXXXXX
 bytes used XXXXXX
@@ -30,8 +29,7 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 40
-			encoding: RAID1
+	item 0 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
 total bytes XXXXXXXX
@@ -49,8 +47,7 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 0 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
 total bytes XXXXXXXX
diff --git a/tests/btrfs/305.out b/tests/btrfs/305.out
index 7090626c3036..02642c904b1e 100644
--- a/tests/btrfs/305.out
+++ b/tests/btrfs/305.out
@@ -14,14 +14,11 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 61440) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 0 key (XXXXXX RAID_STRIPE 61440) itemoff XXXXX itemsize 16
 			stripe 0 devid 1 physical XXXXXXXXX
-	item 1 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 1 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 16
 			stripe 0 devid 1 physical XXXXXXXXX
-	item 2 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 2 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 16
 			stripe 0 devid 2 physical XXXXXXXXX
 total bytes XXXXXXXX
 bytes used XXXXXX
@@ -40,12 +37,10 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 61440) itemoff XXXXX itemsize 40
-			encoding: RAID1
+	item 0 key (XXXXXX RAID_STRIPE 61440) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
-	item 1 key (XXXXXX RAID_STRIPE 8192) itemoff XXXXX itemsize 40
-			encoding: RAID1
+	item 1 key (XXXXXX RAID_STRIPE 8192) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
 total bytes XXXXXXXX
@@ -65,16 +60,13 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 61440) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 0 key (XXXXXX RAID_STRIPE 61440) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
-	item 1 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 1 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
-	item 2 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 2 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 32
 			stripe 0 devid 3 physical XXXXXXXXX
 			stripe 1 devid 4 physical XXXXXXXXX
 total bytes XXXXXXXX
diff --git a/tests/btrfs/306.out b/tests/btrfs/306.out
index 25065674c77b..954567db7623 100644
--- a/tests/btrfs/306.out
+++ b/tests/btrfs/306.out
@@ -14,11 +14,9 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 0 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 16
 			stripe 0 devid 1 physical XXXXXXXXX
-	item 1 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 1 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 16
 			stripe 0 devid 2 physical XXXXXXXXX
 total bytes XXXXXXXX
 bytes used XXXXXX
@@ -37,12 +35,10 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 40
-			encoding: RAID1
+	item 0 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
-	item 1 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 40
-			encoding: RAID1
+	item 1 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
 total bytes XXXXXXXX
@@ -62,12 +58,10 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 0 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
-	item 1 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 1 key (XXXXXX RAID_STRIPE 4096) itemoff XXXXX itemsize 32
 			stripe 0 devid 3 physical XXXXXXXXX
 			stripe 1 devid 4 physical XXXXXXXXX
 total bytes XXXXXXXX
diff --git a/tests/btrfs/307.out b/tests/btrfs/307.out
index 2815d17d7f03..e2f1d3d84a68 100644
--- a/tests/btrfs/307.out
+++ b/tests/btrfs/307.out
@@ -12,11 +12,9 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 0 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 16
 			stripe 0 devid 1 physical XXXXXXXXX
-	item 1 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 1 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 16
 			stripe 0 devid 2 physical XXXXXXXXX
 total bytes XXXXXXXX
 bytes used XXXXXX
@@ -33,8 +31,7 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 131072) itemoff XXXXX itemsize 40
-			encoding: RAID1
+	item 0 key (XXXXXX RAID_STRIPE 131072) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
 total bytes XXXXXXXX
@@ -52,12 +49,10 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 0 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
-	item 1 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 1 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 32
 			stripe 0 devid 3 physical XXXXXXXXX
 			stripe 1 devid 4 physical XXXXXXXXX
 total bytes XXXXXXXX
diff --git a/tests/btrfs/308.out b/tests/btrfs/308.out
index 23b31dd32959..75e010d54252 100644
--- a/tests/btrfs/308.out
+++ b/tests/btrfs/308.out
@@ -16,20 +16,15 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 0 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 16
 			stripe 0 devid 1 physical XXXXXXXXX
-	item 1 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 1 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 16
 			stripe 0 devid 1 physical XXXXXXXXX
-	item 2 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 2 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 16
 			stripe 0 devid 2 physical XXXXXXXXX
-	item 3 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 3 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 16
 			stripe 0 devid 1 physical XXXXXXXXX
-	item 4 key (XXXXXX RAID_STRIPE 8192) itemoff XXXXX itemsize 24
-			encoding: RAID0
+	item 4 key (XXXXXX RAID_STRIPE 8192) itemoff XXXXX itemsize 16
 			stripe 0 devid 1 physical XXXXXXXXX
 total bytes XXXXXXXX
 bytes used XXXXXX
@@ -50,16 +45,13 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 40
-			encoding: RAID1
+	item 0 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
-	item 1 key (XXXXXX RAID_STRIPE 131072) itemoff XXXXX itemsize 40
-			encoding: RAID1
+	item 1 key (XXXXXX RAID_STRIPE 131072) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
-	item 2 key (XXXXXX RAID_STRIPE 8192) itemoff XXXXX itemsize 40
-			encoding: RAID1
+	item 2 key (XXXXXX RAID_STRIPE 8192) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
 total bytes XXXXXXXX
@@ -81,24 +73,19 @@ checksum stored <CHECKSUM>
 checksum calced <CHECKSUM>
 fs uuid <UUID>
 chunk uuid <UUID>
-	item 0 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 0 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
-	item 1 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 1 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
-	item 2 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 2 key (XXXXXX RAID_STRIPE 65536) itemoff XXXXX itemsize 32
 			stripe 0 devid 3 physical XXXXXXXXX
 			stripe 1 devid 4 physical XXXXXXXXX
-	item 3 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 3 key (XXXXXX RAID_STRIPE 32768) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
-	item 4 key (XXXXXX RAID_STRIPE 8192) itemoff XXXXX itemsize 40
-			encoding: RAID10
+	item 4 key (XXXXXX RAID_STRIPE 8192) itemoff XXXXX itemsize 32
 			stripe 0 devid 1 physical XXXXXXXXX
 			stripe 1 devid 2 physical XXXXXXXXX
 total bytes XXXXXXXX