diff --git a/tests/fsck-tests/064-deprecated-inode-cache/4k_nodesize.img.xz b/tests/fsck-tests/064-deprecated-inode-cache/4k_nodesize.img.xz
new file mode 100644
index 0000000000000000000000000000000000000000..da8314bbe3ee4c44b40f8d6cf3efd79b98c30e5a
GIT binary patch
diff --git a/tests/fsck-tests/064-deprecated-inode-cache/test.sh b/tests/fsck-tests/064-deprecated-inode-cache/test.sh
new file mode 100755
index 000000000000..ca3bfa7182a2
--- /dev/null
+++ b/tests/fsck-tests/064-deprecated-inode-cache/test.sh
@@ -0,0 +1,14 @@
+#!/bin/bash
+#
+# Verify that check can report deprecated inode cache as an error
+
+source "$TEST_TOP/common" || exit
+
+check_prereq btrfs
+
+check_image() {
+	run_mustfail "deprecated inode cache not reported as an error" \
+		"$TOP/btrfs" check "$1"
+}
+
+check_all_images